unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Img: TImage;
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  Bmp1: TBitmap;
begin
  // Simple bitmap with white background and yellow circle in it
  // It is transparent with color white so white background doesn't show
  Bmp1 := TBitmap.Create;
  Bmp1.Width:=300;
  Bmp1.Height:=300;
  Bmp1.TransparentColor := clWhite;
  Bmp1.Transparent := true;
  Bmp1.Canvas.Brush.Color := clWhite;
  Bmp1.Canvas.FillRect(Rect(0,0,Bmp1.Width,Bmp1.Height));

  // Now we draw into bitmap yellow ellipse with white(transparent) rectangle
  Bmp1.Canvas.Brush.Color := clYellow;
  Bmp1.Canvas.Ellipse(50,50,200,200);
  Bmp1.Canvas.Brush.Color := clWhite;
  Bmp1.Canvas.Rectangle(80,80,100,100);

  // Now we render it and see everything works fine. There is yellow circle
  // with black box in it (which was white rect, but due to transparency
  // you can see through)
  Img.Canvas.Brush.Color := clBlack;
  Img.Canvas.FillRect(Img.ClientRect);
  Img.Canvas.Draw(50,50, Bmp1);

  // But now, we add red elipse
  Bmp1.Canvas.Brush.Color := clRed;
  Bmp1.Canvas.Ellipse(120,120,170,170);

  // With again white rect, which should be transparent and we
  // should see through black color
  Bmp1.Canvas.Brush.Color := clWhite;
  Bmp1.Canvas.Rectangle(140,140,170,170);

  // We draw it, but it's not transparent!
  Img.Canvas.Brush.Color := clBlack;
  Img.Canvas.FillRect(Img.ClientRect);
  Img.Canvas.Draw(50,50, Bmp1);

end;

initialization
  {$I unit1.lrs}

end.

